#include "silencecheck.h"
#include "dissipate2/messagesocket.h"
#include <qdatetime.h>

SilenceCheck::SilenceCheck()
{
  silenceTimer = new QTimer();
  connect( silenceTimer, SIGNAL( timeout() ), this, SLOT( timerTick() ) );
}


SilenceCheck::~SilenceCheck()
{
  delete silenceTimer;
}


void SilenceCheck::speakerSigUpdated( double vol )
{
  if( fabs( vol ) > volume )
    volume = fabs( vol );
}


void SilenceCheck::timerTick()
{
  if( volume > 0 ) {
    if( silent ) {
      silent = 0;
      printf( "speaker starts transmitting sound: %s\n", QDateTime::currentDateTime().toString( "dd.MM.yyyy hh:mm:ss" ).ascii() );
    }
  }
  else {
    if( !silent ) {
      silent = 1;
      printf( "speaker is silent: %s\n", QDateTime::currentDateTime().toString( "dd.MM.yyyy hh:mm:ss" ).ascii() );
    }
  }
  volume = 0;
  printf( "transmitted packets: sent: %d, received: %d, errors: %d\n",
	  MessageSocket::sendCount(), MessageSocket::receiveCount(), MessageSocket::errorCount() );
  MessageSocket::resetPacketCounter();
}


void SilenceCheck::startTimer()
{
  silent = 1;
  volume = 0;
  silenceTimer->start( 250 );
}


void SilenceCheck::stopTimer()
{
  silenceTimer->stop();
}
