/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include "callcenterVars.h"
#include <qtimer.h>
#include <qsettings.h>


void SoundDialog::init()
{
  microSlider->setValue( (int)(microVol * 25) );
  speakerSlider->setValue( (int)(speakerVol * 100) );
  displayTimer = new QTimer();
  blockChange = 0; // alloy only *one* thread to save the Volumes
  connect( displayTimer, SIGNAL( timeout() ), this, SLOT( timerTick() ) );
  displayTimer->start( 250 );  // update volume bars 4 times a second
}


void SoundDialog::destroy()
{
  soundControlStop();
  displayTimer->stop();
  disconnect( displayTimer, SIGNAL( timeout() ), 0, 0 );
  delete displayTimer;
  system( "/usr/bin/killall kmix" );
}


void SoundDialog::mixerCalled()
{
  setreuid( originalUid, (uid_t)(-1) ); // kmix cannot be run as root!
  printf( "start kmix\n" );
  system( "/opt/kde3/bin/kmix >> kmix.log 2>&1" );
  printf( "opening kmix window\n" );
  system( "/opt/kde3/bin/dcop kmix kmix-mainwindow#1 show" );
  setreuid( 0, (uid_t)(-1) );
}


void SoundDialog::saveCalled()
{
  system( "/usr/sbin/alsactl -f $HOME/.qt/kcenter.alsa store" );
}


void SoundDialog::displaySpeakerVol()
{
  int vol = (int)(speakerVol * 100);
  speakerSlider->setValue( vol );
  speakerChanged();
}


void SoundDialog::displayMicroVol()
{
  int vol = (int)(microVol * 25);
  microSlider->setValue( vol );
  microChanged();
}


void SoundDialog::changeMicroVol( int vol )
{
  microVol = vol / 25.0;
  microChanged();
}


void SoundDialog::changeSpeakerVol( int vol )
{
  speakerVol = vol / 100.0;
  speakerChanged();
}


void SoundDialog::microSigUpdated( double vol )
{
  int ivol = abs( (int)floor( 100 * vol / 32767 ) );
  if( maxMicroVol < ivol )
    maxMicroVol = ivol;
}


void SoundDialog::speakerSigUpdated( double vol )
{
  int ivol = abs( (int)floor( 100 * vol / 32767 ) );
  if( maxSpeakerVol < ivol )
    maxSpeakerVol = ivol;
}


void SoundDialog::timerTick()
{
  speakerSignal->setProgress( maxSpeakerVol );
  microSignal->setProgress( maxMicroVol );
  maxSpeakerVol = 0;
  maxMicroVol = 0;
}


void SoundDialog::microChanged()
{
  int vol = (int)floorf( microVol * 25 );
  microVol = (double)vol / 25.0;
  if( !blockChange ) { // make function thread safe
    blockChange = 1;
    QSettings settings;
    settings.writeEntry( "/kallcenter/sound/microVol", microVol );
    blockChange = 0;
    printf( "Micro volume changed/saved: %f\n", microVol );
  }
}


void SoundDialog::speakerChanged()
{
  int vol = (int)floorf( speakerVol * 100 );
  speakerVol = (double)vol / 100.0;
  if( !blockChange ) { // make function thread safe
    blockChange = 1;
    QSettings settings;
    settings.writeEntry( "/kallcenter/sound/speakerVol", speakerVol );
    blockChange = 0;
    printf( "Speaker volume changed/saved: %f\n", speakerVol );
  }
}
